#include "editor.h"

/* The data is actually already loaded, we just need to extract it into a more editable form */
void load (void)
{
	vertices.clear();
	edges.clear();
	objects.clear();

	for (int i = 0; i < levelN.mNumEdges; i++) {
		Vtx *v1 = find_or_add_vertex (levelN.mPoints[4*i], levelN.mPoints[4*i+1]);
		Vtx *v2 = find_or_add_vertex (levelN.mPoints[4*i+2], levelN.mPoints[4*i+3]);
		edges.push_back (new Edge(v1, v2));
	}

	for (int i = 0; i < levelN.mNumObjects; i++) {
		ObjData *o = levelN.mObjData + i;
		if (o->type != OBJTYPE_NONE) {
			Vtx *v = find_or_add_vertex (o->x, o->y);
			objects.push_back (new Obj (v, o->type, o->id, o->targets, o->data));
		}
	}
}

