#include "editor.h"

Vtx *find_vertex (int x, int y, int tolerance)
{
	list<Vtx *>::iterator it;
	for (it = vertices.begin(); it != vertices.end(); it++)
		if (abs((*it)->x-x) < tolerance && abs((*it)->y-y) < tolerance) return *it;
	return NULL;
}

Vtx *find_or_add_vertex (int x, int y, int tolerance)
{
	Vtx *ret = find_vertex (x, y, tolerance);
	if (ret) return ret;

	ret = new Vtx (x, y);
	vertices.push_back (ret);
	return ret;
}

Vtx *delete_vertex (int x, int y, int tolerance)
{
	Vtx *vtx = find_vertex (x, y, tolerance);
	if (!vtx) return NULL;

	return delete_vertex (vtx);
}

Vtx *delete_vertex (Vtx *vtx)
{
	list<Edge *>::iterator it;
	for (it = edges.begin(); it != edges.end();)
		if ((*it)->v1 == vtx || (*it)->v2 == vtx) {
			delete *it;
			it = edges.erase (it);
		} else {
			it++;
		}

	list<Obj *>::iterator oit;
	for (oit = objects.begin(); oit != objects.end();)
		if ((*oit)->pos == vtx) {
			delete *oit;
			oit = objects.erase (oit);
		} else {
			oit++;
		}

	list<Vtx *>::iterator vit;
	for (vit = vertices.begin(); vit != vertices.end(); vit++)
		if ((*vit) == vtx) {
			vertices.erase (vit);
			break;
		}

	delete vtx;

	return vtx;
}

