// main game

#include "main.h"
#include "game.h"
#include "frontend.h"
#include "heart.h"
#include "arrow.h"
#include "enemy.h"
#include "rocket.h"
#include "particle.h"
#include "heart_trails.h"
#include "panel.h"
#include "sound.h"
#include "gameplay.h"
#include "highscores.h"


int game_time = -1;

void init_game()
{
	in_frontend = false;

    game_time = 0;

	arrows.clear();
	enemies.clear();
	rockets.clear();
	particles.clear();

	if (heart) {
		delete heart;
		heart = NULL;
	}

	init_panel();

	init_level();

	init_heart_trails();
    
    init_gameplay();

	fade_out(16);
	clear(screen);
	set_palette(our_palette);

	do {
	} while (key[KEY_UP] || key[KEY_DOWN] || key[KEY_SPACE] || key[KEY_ENTER] || key[KEY_ESC]);
	
	clear_keybuf();

}



bool update_game()
{
	if ((key[KEY_ESC]) || (heart->mDead) || (!heart->update()) || (!update_gameplay())) {

		stop_engine();

        if(key[KEY_ESC]) {
			menu_click(TRUE);
            do_highscores();
		}

		init_frontend();
		return true;
	}

    game_time++;

    update_heart_trails();

	update_level();

	arrows.update();
	enemies.update();
	rockets.update();
	particles.update();


	update_panel();

	return true;
}



void render_game(BITMAP *bmp)
{
    render_level(bmp);
    
	particles.render(bmp);

	rockets.render(bmp);
	enemies.render(bmp);
	arrows.render(bmp);

	heart->render(bmp);

    render_heart_trails(bmp);

	render_panel(bmp);
}

