// HUD display routines

#ifndef __PANEL_H__
#define __PANEL_H__


#include "main.h"



void init_panel();
void update_panel();
void render_panel(BITMAP *bmp);



// list of player names/health etc
class PlayerPanel
{
public:
	
	PlayerPanel(const char *name)
		: mName(name),
		  mHealth(1),
		  mHitTime(0)
		{ }


	bool operator < (const PlayerPanel &other) const
	{
		return (stricmp(mName, other.mName) < 0);
	}


	const char *mName;
	float mHealth;
	int mHitTime;
};


extern list<PlayerPanel> player_panel;




#endif		// __PANEL_H__


